package com.toughra.ustadmobile.databinding;
import com.toughra.ustadmobile.R;
import com.toughra.ustadmobile.BR;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import android.view.View;
@SuppressWarnings("unchecked")
public class FragmentClazzAssignmentEditBindingImpl extends FragmentClazzAssignmentEditBinding implements com.toughra.ustadmobile.generated.callback.OnClickListener.Listener {

    @Nullable
    private static final androidx.databinding.ViewDataBinding.IncludedLayouts sIncludes;
    @Nullable
    private static final android.util.SparseIntArray sViewsWithIds;
    static {
        sIncludes = new androidx.databinding.ViewDataBinding.IncludedLayouts(27);
        sIncludes.setIncludes(1, 
            new String[] {"item_course_block_common_detail"},
            new int[] {24},
            new int[] {com.toughra.ustadmobile.R.layout.item_course_block_common_detail});
        sViewsWithIds = new android.util.SparseIntArray();
        sViewsWithIds.put(R.id.ca_edit_after_submission, 25);
        sViewsWithIds.put(R.id.ca_edit_marking_type, 26);
    }
    // views
    @NonNull
    private final com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView mboundView10;
    @NonNull
    private final com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView mboundView17;
    @NonNull
    private final com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView mboundView20;
    @NonNull
    private final com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView mboundView21;
    @NonNull
    private final com.google.android.material.textfield.TextInputEditText mboundView7;
    // variables
    @Nullable
    private final android.view.View.OnClickListener mCallback17;
    // values
    private androidx.databinding.InverseBindingListener mOldEventBlock94713904;
    private androidx.databinding.InverseBindingListener mOldEventStartDate290354820;
    private androidx.databinding.InverseBindingListener mOldEventStartTime191363530;
    private androidx.databinding.InverseBindingListener mOldEventDeadlineDate617772217;
    private androidx.databinding.InverseBindingListener mOldEventDeadlineTime374556725;
    private androidx.databinding.InverseBindingListener mOldEventGracePeriodDate1431979498;
    private androidx.databinding.InverseBindingListener mOldEventGracePeriodTime397651991;
    // listeners
    // Inverse Binding Event Handlers
    private androidx.databinding.InverseBindingListener caEditClassCommentsandroidCheckedAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of blockWithAssignment.assignment.caClassCommentEnabled
            //         is blockWithAssignment.assignment.setCaClassCommentEnabled((boolean) callbackArg_0)
            boolean callbackArg_0 = caEditClassComments.isChecked();
            // localize variables for thread safety
            // blockWithAssignment.assignment
            com.ustadmobile.lib.db.entities.ClazzAssignment blockWithAssignmentAssignment = null;
            // blockWithAssignment.assignment != null
            boolean blockWithAssignmentAssignmentJavaLangObjectNull = false;
            // blockWithAssignment.assignment.caClassCommentEnabled
            boolean blockWithAssignmentAssignmentCaClassCommentEnabled = false;
            // blockWithAssignment
            com.ustadmobile.lib.db.entities.CourseBlockWithEntity blockWithAssignment = mBlockWithAssignment;
            // blockWithAssignment != null
            boolean blockWithAssignmentJavaLangObjectNull = false;



            blockWithAssignmentJavaLangObjectNull = (blockWithAssignment) != (null);
            if (blockWithAssignmentJavaLangObjectNull) {


                blockWithAssignmentAssignment = blockWithAssignment.getAssignment();

                blockWithAssignmentAssignmentJavaLangObjectNull = (blockWithAssignmentAssignment) != (null);
                if (blockWithAssignmentAssignmentJavaLangObjectNull) {




                    blockWithAssignmentAssignment.setCaClassCommentEnabled(((boolean) (callbackArg_0)));
                }
            }
        }
    };
    private androidx.databinding.ViewDataBinding.PropertyChangedInverseListener caEditCommonFieldsblock = new androidx.databinding.ViewDataBinding.PropertyChangedInverseListener(BR.block) {
        @Override
        public void onChange() {
            // Inverse of (CourseBlock) blockWithAssignment
            //         is com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this.setBlockWithAssignment((com.ustadmobile.lib.db.entities.CourseBlockWithEntity) callbackArg_0)
            com.ustadmobile.lib.db.entities.CourseBlock callbackArg_0 = caEditCommonFields.getBlock();
            // localize variables for thread safety
            // (CourseBlock) blockWithAssignment
            com.ustadmobile.lib.db.entities.CourseBlock courseBlockBlockWithAssignment = null;
            // blockWithAssignment
            com.ustadmobile.lib.db.entities.CourseBlockWithEntity blockWithAssignment = mBlockWithAssignment;


            if ((com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this) != (null)) {




                com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this.setBlockWithAssignment(((com.ustadmobile.lib.db.entities.CourseBlockWithEntity) (callbackArg_0)));
            }
        }
    };
    private androidx.databinding.ViewDataBinding.PropertyChangedInverseListener caEditCommonFieldsstartDate = new androidx.databinding.ViewDataBinding.PropertyChangedInverseListener(BR.startDate) {
        @Override
        public void onChange() {
            // Inverse of startDate
            //         is com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this.setStartDate(callbackArg_0)
            long callbackArg_0 = caEditCommonFields.getStartDate();
            // localize variables for thread safety
            // startDate
            long startDate = mStartDate;


            if ((com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this) != (null)) {



                com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this.setStartDate(callbackArg_0);
            }
        }
    };
    private androidx.databinding.ViewDataBinding.PropertyChangedInverseListener caEditCommonFieldsstartTime = new androidx.databinding.ViewDataBinding.PropertyChangedInverseListener(BR.startTime) {
        @Override
        public void onChange() {
            // Inverse of startTime
            //         is com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this.setStartTime(callbackArg_0)
            long callbackArg_0 = caEditCommonFields.getStartTime();
            // localize variables for thread safety
            // startTime
            long startTime = mStartTime;


            if ((com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this) != (null)) {



                com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this.setStartTime(callbackArg_0);
            }
        }
    };
    private androidx.databinding.ViewDataBinding.PropertyChangedInverseListener caEditCommonFieldsdeadlineDate = new androidx.databinding.ViewDataBinding.PropertyChangedInverseListener(BR.deadlineDate) {
        @Override
        public void onChange() {
            // Inverse of deadlineDate
            //         is com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this.setDeadlineDate(callbackArg_0)
            long callbackArg_0 = caEditCommonFields.getDeadlineDate();
            // localize variables for thread safety
            // deadlineDate
            long deadlineDate = mDeadlineDate;


            if ((com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this) != (null)) {



                com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this.setDeadlineDate(callbackArg_0);
            }
        }
    };
    private androidx.databinding.ViewDataBinding.PropertyChangedInverseListener caEditCommonFieldsdeadlineTime = new androidx.databinding.ViewDataBinding.PropertyChangedInverseListener(BR.deadlineTime) {
        @Override
        public void onChange() {
            // Inverse of deadlineTime
            //         is com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this.setDeadlineTime(callbackArg_0)
            long callbackArg_0 = caEditCommonFields.getDeadlineTime();
            // localize variables for thread safety
            // deadlineTime
            long deadlineTime = mDeadlineTime;


            if ((com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this) != (null)) {



                com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this.setDeadlineTime(callbackArg_0);
            }
        }
    };
    private androidx.databinding.ViewDataBinding.PropertyChangedInverseListener caEditCommonFieldsgracePeriodDate = new androidx.databinding.ViewDataBinding.PropertyChangedInverseListener(BR.gracePeriodDate) {
        @Override
        public void onChange() {
            // Inverse of gracePeriodDate
            //         is com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this.setGracePeriodDate(callbackArg_0)
            long callbackArg_0 = caEditCommonFields.getGracePeriodDate();
            // localize variables for thread safety
            // gracePeriodDate
            long gracePeriodDate = mGracePeriodDate;


            if ((com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this) != (null)) {



                com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this.setGracePeriodDate(callbackArg_0);
            }
        }
    };
    private androidx.databinding.ViewDataBinding.PropertyChangedInverseListener caEditCommonFieldsgracePeriodTime = new androidx.databinding.ViewDataBinding.PropertyChangedInverseListener(BR.gracePeriodTime) {
        @Override
        public void onChange() {
            // Inverse of gracePeriodTime
            //         is com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this.setGracePeriodTime(callbackArg_0)
            long callbackArg_0 = caEditCommonFields.getGracePeriodTime();
            // localize variables for thread safety
            // gracePeriodTime
            long gracePeriodTime = mGracePeriodTime;


            if ((com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this) != (null)) {



                com.toughra.ustadmobile.databinding.FragmentClazzAssignmentEditBindingImpl.this.setGracePeriodTime(callbackArg_0);
            }
        }
    };
    private androidx.databinding.InverseBindingListener caEditDescTextandroidTextAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of blockWithAssignment.assignment.caDescription
            //         is blockWithAssignment.assignment.setCaDescription((java.lang.String) callbackArg_0)
            java.lang.String callbackArg_0 = androidx.databinding.adapters.TextViewBindingAdapter.getTextString(caEditDescText);
            // localize variables for thread safety
            // blockWithAssignment.assignment.caDescription
            java.lang.String blockWithAssignmentAssignmentCaDescription = null;
            // blockWithAssignment.assignment
            com.ustadmobile.lib.db.entities.ClazzAssignment blockWithAssignmentAssignment = null;
            // blockWithAssignment.assignment != null
            boolean blockWithAssignmentAssignmentJavaLangObjectNull = false;
            // blockWithAssignment
            com.ustadmobile.lib.db.entities.CourseBlockWithEntity blockWithAssignment = mBlockWithAssignment;
            // blockWithAssignment != null
            boolean blockWithAssignmentJavaLangObjectNull = false;



            blockWithAssignmentJavaLangObjectNull = (blockWithAssignment) != (null);
            if (blockWithAssignmentJavaLangObjectNull) {


                blockWithAssignmentAssignment = blockWithAssignment.getAssignment();

                blockWithAssignmentAssignmentJavaLangObjectNull = (blockWithAssignmentAssignment) != (null);
                if (blockWithAssignmentAssignmentJavaLangObjectNull) {




                    blockWithAssignmentAssignment.setCaDescription(((java.lang.String) (callbackArg_0)));
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener caEditFileSizeLimitDescandroidTextAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of ("") + (blockWithAssignment.assignment.caSizeLimit)
            //         is blockWithAssignment.assignment.setCaSizeLimit((int) androidx.databinding.ViewDataBinding.parse(callbackArg_0, blockWithAssignment.assignment.caSizeLimit))
            java.lang.String callbackArg_0 = androidx.databinding.adapters.TextViewBindingAdapter.getTextString(caEditFileSizeLimitDesc);
            // localize variables for thread safety
            // androidx.databinding.ViewDataBinding.parse(callbackArg_0, blockWithAssignment.assignment.caSizeLimit)
            int androidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaSizeLimit = 0;
            // blockWithAssignment.assignment != null
            boolean blockWithAssignmentAssignmentJavaLangObjectNull = false;
            // ("") + (blockWithAssignment.assignment.caSizeLimit)
            java.lang.String javaLangStringBlockWithAssignmentAssignmentCaSizeLimit = null;
            // blockWithAssignment != null
            boolean blockWithAssignmentJavaLangObjectNull = false;
            // (int) androidx.databinding.ViewDataBinding.parse(callbackArg_0, blockWithAssignment.assignment.caSizeLimit)
            int intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaSizeLimit = 0;
            // blockWithAssignment.assignment
            com.ustadmobile.lib.db.entities.ClazzAssignment blockWithAssignmentAssignment = null;
            // blockWithAssignment.assignment.caSizeLimit
            int blockWithAssignmentAssignmentCaSizeLimit = 0;
            // blockWithAssignment
            com.ustadmobile.lib.db.entities.CourseBlockWithEntity blockWithAssignment = mBlockWithAssignment;



            blockWithAssignmentJavaLangObjectNull = (blockWithAssignment) != (null);
            if (blockWithAssignmentJavaLangObjectNull) {


                blockWithAssignmentAssignment = blockWithAssignment.getAssignment();

                blockWithAssignmentAssignmentJavaLangObjectNull = (blockWithAssignmentAssignment) != (null);
                if (blockWithAssignmentAssignmentJavaLangObjectNull) {






                    blockWithAssignmentAssignmentCaSizeLimit = blockWithAssignmentAssignment.getCaSizeLimit();

                    androidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaSizeLimit = androidx.databinding.ViewDataBinding.parse(callbackArg_0, blockWithAssignmentAssignmentCaSizeLimit);

                    intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaSizeLimit = ((int) (androidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaSizeLimit));

                    blockWithAssignmentAssignment.setCaSizeLimit(intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaSizeLimit);
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener caEditNumberOfFilesDescandroidTextAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of ("") + (blockWithAssignment.assignment.caNumberOfFiles)
            //         is blockWithAssignment.assignment.setCaNumberOfFiles((int) androidx.databinding.ViewDataBinding.parse(callbackArg_0, blockWithAssignment.assignment.caNumberOfFiles))
            java.lang.String callbackArg_0 = androidx.databinding.adapters.TextViewBindingAdapter.getTextString(caEditNumberOfFilesDesc);
            // localize variables for thread safety
            // blockWithAssignment.assignment != null
            boolean blockWithAssignmentAssignmentJavaLangObjectNull = false;
            // (int) androidx.databinding.ViewDataBinding.parse(callbackArg_0, blockWithAssignment.assignment.caNumberOfFiles)
            int intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaNumberOfFiles = 0;
            // androidx.databinding.ViewDataBinding.parse(callbackArg_0, blockWithAssignment.assignment.caNumberOfFiles)
            int androidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaNumberOfFiles = 0;
            // blockWithAssignment != null
            boolean blockWithAssignmentJavaLangObjectNull = false;
            // blockWithAssignment.assignment.caNumberOfFiles
            int blockWithAssignmentAssignmentCaNumberOfFiles = 0;
            // blockWithAssignment.assignment
            com.ustadmobile.lib.db.entities.ClazzAssignment blockWithAssignmentAssignment = null;
            // ("") + (blockWithAssignment.assignment.caNumberOfFiles)
            java.lang.String javaLangStringBlockWithAssignmentAssignmentCaNumberOfFiles = null;
            // blockWithAssignment
            com.ustadmobile.lib.db.entities.CourseBlockWithEntity blockWithAssignment = mBlockWithAssignment;



            blockWithAssignmentJavaLangObjectNull = (blockWithAssignment) != (null);
            if (blockWithAssignmentJavaLangObjectNull) {


                blockWithAssignmentAssignment = blockWithAssignment.getAssignment();

                blockWithAssignmentAssignmentJavaLangObjectNull = (blockWithAssignmentAssignment) != (null);
                if (blockWithAssignmentAssignmentJavaLangObjectNull) {






                    blockWithAssignmentAssignmentCaNumberOfFiles = blockWithAssignmentAssignment.getCaNumberOfFiles();

                    androidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaNumberOfFiles = androidx.databinding.ViewDataBinding.parse(callbackArg_0, blockWithAssignmentAssignmentCaNumberOfFiles);

                    intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaNumberOfFiles = ((int) (androidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaNumberOfFiles));

                    blockWithAssignmentAssignment.setCaNumberOfFiles(intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaNumberOfFiles);
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener caEditNumberOfWordsDescandroidTextAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of ("") + (blockWithAssignment.assignment.caTextLimit)
            //         is blockWithAssignment.assignment.setCaTextLimit((int) androidx.databinding.ViewDataBinding.parse(callbackArg_0, blockWithAssignment.assignment.caTextLimit))
            java.lang.String callbackArg_0 = androidx.databinding.adapters.TextViewBindingAdapter.getTextString(caEditNumberOfWordsDesc);
            // localize variables for thread safety
            // blockWithAssignment.assignment != null
            boolean blockWithAssignmentAssignmentJavaLangObjectNull = false;
            // (int) androidx.databinding.ViewDataBinding.parse(callbackArg_0, blockWithAssignment.assignment.caTextLimit)
            int intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaTextLimit = 0;
            // blockWithAssignment != null
            boolean blockWithAssignmentJavaLangObjectNull = false;
            // blockWithAssignment.assignment
            com.ustadmobile.lib.db.entities.ClazzAssignment blockWithAssignmentAssignment = null;
            // blockWithAssignment.assignment.caTextLimit
            int blockWithAssignmentAssignmentCaTextLimit = 0;
            // androidx.databinding.ViewDataBinding.parse(callbackArg_0, blockWithAssignment.assignment.caTextLimit)
            int androidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaTextLimit = 0;
            // ("") + (blockWithAssignment.assignment.caTextLimit)
            java.lang.String javaLangStringBlockWithAssignmentAssignmentCaTextLimit = null;
            // blockWithAssignment
            com.ustadmobile.lib.db.entities.CourseBlockWithEntity blockWithAssignment = mBlockWithAssignment;



            blockWithAssignmentJavaLangObjectNull = (blockWithAssignment) != (null);
            if (blockWithAssignmentJavaLangObjectNull) {


                blockWithAssignmentAssignment = blockWithAssignment.getAssignment();

                blockWithAssignmentAssignmentJavaLangObjectNull = (blockWithAssignmentAssignment) != (null);
                if (blockWithAssignmentAssignmentJavaLangObjectNull) {






                    blockWithAssignmentAssignmentCaTextLimit = blockWithAssignmentAssignment.getCaTextLimit();

                    androidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaTextLimit = androidx.databinding.ViewDataBinding.parse(callbackArg_0, blockWithAssignmentAssignmentCaTextLimit);

                    intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaTextLimit = ((int) (androidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaTextLimit));

                    blockWithAssignmentAssignment.setCaTextLimit(intAndroidxDatabindingViewDataBindingParseCallbackArg0BlockWithAssignmentAssignmentCaTextLimit);
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener caEditPrivateCommentsandroidCheckedAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of blockWithAssignment.assignment.caPrivateCommentsEnabled
            //         is blockWithAssignment.assignment.setCaPrivateCommentsEnabled((boolean) callbackArg_0)
            boolean callbackArg_0 = caEditPrivateComments.isChecked();
            // localize variables for thread safety
            // blockWithAssignment.assignment.caPrivateCommentsEnabled
            boolean blockWithAssignmentAssignmentCaPrivateCommentsEnabled = false;
            // blockWithAssignment.assignment
            com.ustadmobile.lib.db.entities.ClazzAssignment blockWithAssignmentAssignment = null;
            // blockWithAssignment.assignment != null
            boolean blockWithAssignmentAssignmentJavaLangObjectNull = false;
            // blockWithAssignment
            com.ustadmobile.lib.db.entities.CourseBlockWithEntity blockWithAssignment = mBlockWithAssignment;
            // blockWithAssignment != null
            boolean blockWithAssignmentJavaLangObjectNull = false;



            blockWithAssignmentJavaLangObjectNull = (blockWithAssignment) != (null);
            if (blockWithAssignmentJavaLangObjectNull) {


                blockWithAssignmentAssignment = blockWithAssignment.getAssignment();

                blockWithAssignmentAssignmentJavaLangObjectNull = (blockWithAssignmentAssignment) != (null);
                if (blockWithAssignmentAssignmentJavaLangObjectNull) {




                    blockWithAssignmentAssignment.setCaPrivateCommentsEnabled(((boolean) (callbackArg_0)));
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener caEditRequireFileSubmissionandroidCheckedAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of blockWithAssignment.assignment.caRequireFileSubmission
            //         is blockWithAssignment.assignment.setCaRequireFileSubmission((boolean) callbackArg_0)
            boolean callbackArg_0 = caEditRequireFileSubmission.isChecked();
            // localize variables for thread safety
            // blockWithAssignment.assignment
            com.ustadmobile.lib.db.entities.ClazzAssignment blockWithAssignmentAssignment = null;
            // blockWithAssignment.assignment != null
            boolean blockWithAssignmentAssignmentJavaLangObjectNull = false;
            // blockWithAssignment.assignment.caRequireFileSubmission
            boolean blockWithAssignmentAssignmentCaRequireFileSubmission = false;
            // blockWithAssignment
            com.ustadmobile.lib.db.entities.CourseBlockWithEntity blockWithAssignment = mBlockWithAssignment;
            // blockWithAssignment != null
            boolean blockWithAssignmentJavaLangObjectNull = false;



            blockWithAssignmentJavaLangObjectNull = (blockWithAssignment) != (null);
            if (blockWithAssignmentJavaLangObjectNull) {


                blockWithAssignmentAssignment = blockWithAssignment.getAssignment();

                blockWithAssignmentAssignmentJavaLangObjectNull = (blockWithAssignmentAssignment) != (null);
                if (blockWithAssignmentAssignmentJavaLangObjectNull) {




                    blockWithAssignmentAssignment.setCaRequireFileSubmission(((boolean) (callbackArg_0)));
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener caEditRequireTextSubmissionandroidCheckedAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of blockWithAssignment.assignment.caRequireTextSubmission
            //         is blockWithAssignment.assignment.setCaRequireTextSubmission((boolean) callbackArg_0)
            boolean callbackArg_0 = caEditRequireTextSubmission.isChecked();
            // localize variables for thread safety
            // blockWithAssignment.assignment
            com.ustadmobile.lib.db.entities.ClazzAssignment blockWithAssignmentAssignment = null;
            // blockWithAssignment.assignment.caRequireTextSubmission
            boolean blockWithAssignmentAssignmentCaRequireTextSubmission = false;
            // blockWithAssignment.assignment != null
            boolean blockWithAssignmentAssignmentJavaLangObjectNull = false;
            // blockWithAssignment
            com.ustadmobile.lib.db.entities.CourseBlockWithEntity blockWithAssignment = mBlockWithAssignment;
            // blockWithAssignment != null
            boolean blockWithAssignmentJavaLangObjectNull = false;



            blockWithAssignmentJavaLangObjectNull = (blockWithAssignment) != (null);
            if (blockWithAssignmentJavaLangObjectNull) {


                blockWithAssignmentAssignment = blockWithAssignment.getAssignment();

                blockWithAssignmentAssignmentJavaLangObjectNull = (blockWithAssignmentAssignment) != (null);
                if (blockWithAssignmentAssignmentJavaLangObjectNull) {




                    blockWithAssignmentAssignment.setCaRequireTextSubmission(((boolean) (callbackArg_0)));
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener caTitleTextandroidTextAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of blockWithAssignment.assignment.caTitle
            //         is blockWithAssignment.assignment.setCaTitle((java.lang.String) callbackArg_0)
            java.lang.String callbackArg_0 = androidx.databinding.adapters.TextViewBindingAdapter.getTextString(caTitleText);
            // localize variables for thread safety
            // blockWithAssignment.assignment.caTitle
            java.lang.String blockWithAssignmentAssignmentCaTitle = null;
            // blockWithAssignment.assignment
            com.ustadmobile.lib.db.entities.ClazzAssignment blockWithAssignmentAssignment = null;
            // blockWithAssignment.assignment != null
            boolean blockWithAssignmentAssignmentJavaLangObjectNull = false;
            // blockWithAssignment
            com.ustadmobile.lib.db.entities.CourseBlockWithEntity blockWithAssignment = mBlockWithAssignment;
            // blockWithAssignment != null
            boolean blockWithAssignmentJavaLangObjectNull = false;



            blockWithAssignmentJavaLangObjectNull = (blockWithAssignment) != (null);
            if (blockWithAssignmentJavaLangObjectNull) {


                blockWithAssignmentAssignment = blockWithAssignment.getAssignment();

                blockWithAssignmentAssignmentJavaLangObjectNull = (blockWithAssignmentAssignment) != (null);
                if (blockWithAssignmentAssignmentJavaLangObjectNull) {




                    blockWithAssignmentAssignment.setCaTitle(((java.lang.String) (callbackArg_0)));
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener mboundView10selectedMessageIdOptionAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of blockWithAssignment.assignment.caFileType
            //         is blockWithAssignment.assignment.setCaFileType((int) callbackArg_0)
            int callbackArg_0 = com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.getSelectedMessageIdOption(mboundView10);
            // localize variables for thread safety
            // blockWithAssignment.assignment
            com.ustadmobile.lib.db.entities.ClazzAssignment blockWithAssignmentAssignment = null;
            // blockWithAssignment.assignment != null
            boolean blockWithAssignmentAssignmentJavaLangObjectNull = false;
            // blockWithAssignment.assignment.caFileType
            int blockWithAssignmentAssignmentCaFileType = 0;
            // blockWithAssignment
            com.ustadmobile.lib.db.entities.CourseBlockWithEntity blockWithAssignment = mBlockWithAssignment;
            // blockWithAssignment != null
            boolean blockWithAssignmentJavaLangObjectNull = false;



            blockWithAssignmentJavaLangObjectNull = (blockWithAssignment) != (null);
            if (blockWithAssignmentJavaLangObjectNull) {


                blockWithAssignmentAssignment = blockWithAssignment.getAssignment();

                blockWithAssignmentAssignmentJavaLangObjectNull = (blockWithAssignmentAssignment) != (null);
                if (blockWithAssignmentAssignmentJavaLangObjectNull) {




                    blockWithAssignmentAssignment.setCaFileType(((int) (callbackArg_0)));
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener mboundView17selectedMessageIdOptionAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of blockWithAssignment.assignment.caTextLimitType
            //         is blockWithAssignment.assignment.setCaTextLimitType((int) callbackArg_0)
            int callbackArg_0 = com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.getSelectedMessageIdOption(mboundView17);
            // localize variables for thread safety
            // blockWithAssignment.assignment
            com.ustadmobile.lib.db.entities.ClazzAssignment blockWithAssignmentAssignment = null;
            // blockWithAssignment.assignment != null
            boolean blockWithAssignmentAssignmentJavaLangObjectNull = false;
            // blockWithAssignment.assignment.caTextLimitType
            int blockWithAssignmentAssignmentCaTextLimitType = 0;
            // blockWithAssignment
            com.ustadmobile.lib.db.entities.CourseBlockWithEntity blockWithAssignment = mBlockWithAssignment;
            // blockWithAssignment != null
            boolean blockWithAssignmentJavaLangObjectNull = false;



            blockWithAssignmentJavaLangObjectNull = (blockWithAssignment) != (null);
            if (blockWithAssignmentJavaLangObjectNull) {


                blockWithAssignmentAssignment = blockWithAssignment.getAssignment();

                blockWithAssignmentAssignmentJavaLangObjectNull = (blockWithAssignmentAssignment) != (null);
                if (blockWithAssignmentAssignmentJavaLangObjectNull) {




                    blockWithAssignmentAssignment.setCaTextLimitType(((int) (callbackArg_0)));
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener mboundView20selectedMessageIdOptionAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of blockWithAssignment.assignment.caSubmissionPolicy
            //         is blockWithAssignment.assignment.setCaSubmissionPolicy((int) callbackArg_0)
            int callbackArg_0 = com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.getSelectedMessageIdOption(mboundView20);
            // localize variables for thread safety
            // blockWithAssignment.assignment
            com.ustadmobile.lib.db.entities.ClazzAssignment blockWithAssignmentAssignment = null;
            // blockWithAssignment.assignment != null
            boolean blockWithAssignmentAssignmentJavaLangObjectNull = false;
            // blockWithAssignment.assignment.caSubmissionPolicy
            int blockWithAssignmentAssignmentCaSubmissionPolicy = 0;
            // blockWithAssignment
            com.ustadmobile.lib.db.entities.CourseBlockWithEntity blockWithAssignment = mBlockWithAssignment;
            // blockWithAssignment != null
            boolean blockWithAssignmentJavaLangObjectNull = false;



            blockWithAssignmentJavaLangObjectNull = (blockWithAssignment) != (null);
            if (blockWithAssignmentJavaLangObjectNull) {


                blockWithAssignmentAssignment = blockWithAssignment.getAssignment();

                blockWithAssignmentAssignmentJavaLangObjectNull = (blockWithAssignmentAssignment) != (null);
                if (blockWithAssignmentAssignmentJavaLangObjectNull) {




                    blockWithAssignmentAssignment.setCaSubmissionPolicy(((int) (callbackArg_0)));
                }
            }
        }
    };
    private androidx.databinding.InverseBindingListener mboundView21selectedMessageIdOptionAttrChanged = new androidx.databinding.InverseBindingListener() {
        @Override
        public void onChange() {
            // Inverse of blockWithAssignment.assignment.caMarkingType
            //         is blockWithAssignment.assignment.setCaMarkingType((int) callbackArg_0)
            int callbackArg_0 = com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.getSelectedMessageIdOption(mboundView21);
            // localize variables for thread safety
            // blockWithAssignment.assignment
            com.ustadmobile.lib.db.entities.ClazzAssignment blockWithAssignmentAssignment = null;
            // blockWithAssignment.assignment != null
            boolean blockWithAssignmentAssignmentJavaLangObjectNull = false;
            // blockWithAssignment.assignment.caMarkingType
            int blockWithAssignmentAssignmentCaMarkingType = 0;
            // blockWithAssignment
            com.ustadmobile.lib.db.entities.CourseBlockWithEntity blockWithAssignment = mBlockWithAssignment;
            // blockWithAssignment != null
            boolean blockWithAssignmentJavaLangObjectNull = false;



            blockWithAssignmentJavaLangObjectNull = (blockWithAssignment) != (null);
            if (blockWithAssignmentJavaLangObjectNull) {


                blockWithAssignmentAssignment = blockWithAssignment.getAssignment();

                blockWithAssignmentAssignmentJavaLangObjectNull = (blockWithAssignmentAssignment) != (null);
                if (blockWithAssignmentAssignmentJavaLangObjectNull) {




                    blockWithAssignmentAssignment.setCaMarkingType(((int) (callbackArg_0)));
                }
            }
        }
    };

    public FragmentClazzAssignmentEditBindingImpl(@Nullable androidx.databinding.DataBindingComponent bindingComponent, @NonNull View root) {
        this(bindingComponent, root, mapBindings(bindingComponent, root, 27, sIncludes, sViewsWithIds));
    }
    private FragmentClazzAssignmentEditBindingImpl(androidx.databinding.DataBindingComponent bindingComponent, View root, Object[] bindings) {
        super(bindingComponent, root, 1
            , (com.google.android.material.textfield.TextInputLayout) bindings[25]
            , (com.google.android.material.textfield.TextInputLayout) bindings[6]
            , (com.google.android.material.switchmaterial.SwitchMaterial) bindings[22]
            , (com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBinding) bindings[24]
            , (com.google.android.material.textfield.TextInputEditText) bindings[5]
            , (com.google.android.material.textfield.TextInputLayout) bindings[4]
            , (com.google.android.material.textfield.TextInputLayout) bindings[11]
            , (com.google.android.material.textfield.TextInputEditText) bindings[12]
            , (com.google.android.material.textfield.TextInputLayout) bindings[9]
            , (com.google.android.material.textfield.TextInputLayout) bindings[26]
            , (com.google.android.material.textfield.TextInputLayout) bindings[13]
            , (com.google.android.material.textfield.TextInputEditText) bindings[14]
            , (com.google.android.material.textfield.TextInputLayout) bindings[18]
            , (com.google.android.material.textfield.TextInputEditText) bindings[19]
            , (com.google.android.material.switchmaterial.SwitchMaterial) bindings[23]
            , (com.google.android.material.switchmaterial.SwitchMaterial) bindings[8]
            , (com.google.android.material.switchmaterial.SwitchMaterial) bindings[15]
            , (com.google.android.material.textfield.TextInputLayout) bindings[16]
            , (com.google.android.material.textfield.TextInputLayout) bindings[2]
            , (com.google.android.material.textfield.TextInputEditText) bindings[3]
            , (androidx.constraintlayout.widget.ConstraintLayout) bindings[1]
            , (androidx.core.widget.NestedScrollView) bindings[0]
            );
        this.caEditAssignmentType.setTag(null);
        this.caEditClassComments.setTag(null);
        setContainedBinding(this.caEditCommonFields);
        this.caEditDescText.setTag(null);
        this.caEditDescriptionTextinput.setTag(null);
        this.caEditFileSizeLimit.setTag(null);
        this.caEditFileSizeLimitDesc.setTag(null);
        this.caEditFileType.setTag(null);
        this.caEditNumberOfFiles.setTag(null);
        this.caEditNumberOfFilesDesc.setTag(null);
        this.caEditNumberOfWords.setTag(null);
        this.caEditNumberOfWordsDesc.setTag(null);
        this.caEditPrivateComments.setTag(null);
        this.caEditRequireFileSubmission.setTag(null);
        this.caEditRequireTextSubmission.setTag(null);
        this.caEditWordLimit.setTag(null);
        this.caTitleInput.setTag(null);
        this.caTitleText.setTag(null);
        this.fragmentClazzAssignmentEditEditClx.setTag(null);
        this.fragmentClazzAssignmentEditEditScroll.setTag(null);
        this.mboundView10 = (com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView) bindings[10];
        this.mboundView10.setTag(null);
        this.mboundView17 = (com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView) bindings[17];
        this.mboundView17.setTag(null);
        this.mboundView20 = (com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView) bindings[20];
        this.mboundView20.setTag(null);
        this.mboundView21 = (com.ustadmobile.port.android.view.IdOptionAutoCompleteTextView) bindings[21];
        this.mboundView21.setTag(null);
        this.mboundView7 = (com.google.android.material.textfield.TextInputEditText) bindings[7];
        this.mboundView7.setTag(null);
        setRootTag(root);
        // listeners
        mCallback17 = new com.toughra.ustadmobile.generated.callback.OnClickListener(this, 1);
        invalidateAll();
    }

    @Override
    public void invalidateAll() {
        synchronized(this) {
                mDirtyFlags = 0x20000000L;
        }
        caEditCommonFields.invalidateAll();
        requestRebind();
    }

    @Override
    public boolean hasPendingBindings() {
        synchronized(this) {
            if (mDirtyFlags != 0) {
                return true;
            }
        }
        if (caEditCommonFields.hasPendingBindings()) {
            return true;
        }
        return false;
    }

    @Override
    public boolean setVariable(int variableId, @Nullable Object variable)  {
        boolean variableSet = true;
        if (BR.deadlineDate == variableId) {
            setDeadlineDate((long) variable);
        }
        else if (BR.fileTypeOptions == variableId) {
            setFileTypeOptions((java.util.List<com.ustadmobile.core.util.IdOption>) variable);
        }
        else if (BR.textSubmissionVisibility == variableId) {
            setTextSubmissionVisibility((int) variable);
        }
        else if (BR.gracePeriodDate == variableId) {
            setGracePeriodDate((long) variable);
        }
        else if (BR.caStartDateError == variableId) {
            setCaStartDateError((java.lang.String) variable);
        }
        else if (BR.groupSet == variableId) {
            setGroupSet((com.ustadmobile.lib.db.entities.CourseGroupSet) variable);
        }
        else if (BR.gracePeriodVisibility == variableId) {
            setGracePeriodVisibility((int) variable);
        }
        else if (BR.caMaxPointsError == variableId) {
            setCaMaxPointsError((java.lang.String) variable);
        }
        else if (BR.fileSubmissionVisibility == variableId) {
            setFileSubmissionVisibility((int) variable);
        }
        else if (BR.gracePeriodTime == variableId) {
            setGracePeriodTime((long) variable);
        }
        else if (BR.completionCriteriaOptions == variableId) {
            setCompletionCriteriaOptions((java.util.List<com.ustadmobile.core.util.IdOption>) variable);
        }
        else if (BR.textLimitTypeOptions == variableId) {
            setTextLimitTypeOptions((java.util.List<com.ustadmobile.core.util.IdOption>) variable);
        }
        else if (BR.submissionPolicy == variableId) {
            setSubmissionPolicy((java.util.List<com.ustadmobile.core.util.IdOption>) variable);
        }
        else if (BR.startTime == variableId) {
            setStartTime((long) variable);
        }
        else if (BR.fileRequiredListener == variableId) {
            setFileRequiredListener((android.widget.CompoundButton.OnCheckedChangeListener) variable);
        }
        else if (BR.deadlineTime == variableId) {
            setDeadlineTime((long) variable);
        }
        else if (BR.markingTypeOptions == variableId) {
            setMarkingTypeOptions((java.util.List<com.ustadmobile.core.util.IdOption>) variable);
        }
        else if (BR.textRequiredListener == variableId) {
            setTextRequiredListener((android.widget.CompoundButton.OnCheckedChangeListener) variable);
        }
        else if (BR.loading == variableId) {
            setLoading((boolean) variable);
        }
        else if (BR.caGracePeriodError == variableId) {
            setCaGracePeriodError((java.lang.String) variable);
        }
        else if (BR.mPresenter == variableId) {
            setMPresenter((com.ustadmobile.core.controller.ClazzAssignmentEditPresenter) variable);
        }
        else if (BR.timeZone == variableId) {
            setTimeZone((java.lang.String) variable);
        }
        else if (BR.fieldsEnabled == variableId) {
            setFieldsEnabled((boolean) variable);
        }
        else if (BR.groupSetEnabled == variableId) {
            setGroupSetEnabled((java.lang.Boolean) variable);
        }
        else if (BR.caTitleError == variableId) {
            setCaTitleError((java.lang.String) variable);
        }
        else if (BR.startDate == variableId) {
            setStartDate((long) variable);
        }
        else if (BR.caDeadlineError == variableId) {
            setCaDeadlineError((java.lang.String) variable);
        }
        else if (BR.blockWithAssignment == variableId) {
            setBlockWithAssignment((com.ustadmobile.lib.db.entities.CourseBlockWithEntity) variable);
        }
        else {
            variableSet = false;
        }
            return variableSet;
    }

    public void setDeadlineDate(long DeadlineDate) {
        this.mDeadlineDate = DeadlineDate;
        synchronized(this) {
            mDirtyFlags |= 0x2L;
        }
        notifyPropertyChanged(BR.deadlineDate);
        super.requestRebind();
    }
    public void setFileTypeOptions(@Nullable java.util.List<com.ustadmobile.core.util.IdOption> FileTypeOptions) {
        this.mFileTypeOptions = FileTypeOptions;
        synchronized(this) {
            mDirtyFlags |= 0x4L;
        }
        notifyPropertyChanged(BR.fileTypeOptions);
        super.requestRebind();
    }
    public void setTextSubmissionVisibility(int TextSubmissionVisibility) {
        this.mTextSubmissionVisibility = TextSubmissionVisibility;
        synchronized(this) {
            mDirtyFlags |= 0x8L;
        }
        notifyPropertyChanged(BR.textSubmissionVisibility);
        super.requestRebind();
    }
    public void setGracePeriodDate(long GracePeriodDate) {
        this.mGracePeriodDate = GracePeriodDate;
        synchronized(this) {
            mDirtyFlags |= 0x10L;
        }
        notifyPropertyChanged(BR.gracePeriodDate);
        super.requestRebind();
    }
    public void setCaStartDateError(@Nullable java.lang.String CaStartDateError) {
        this.mCaStartDateError = CaStartDateError;
        synchronized(this) {
            mDirtyFlags |= 0x20L;
        }
        notifyPropertyChanged(BR.caStartDateError);
        super.requestRebind();
    }
    public void setGroupSet(@Nullable com.ustadmobile.lib.db.entities.CourseGroupSet GroupSet) {
        this.mGroupSet = GroupSet;
        synchronized(this) {
            mDirtyFlags |= 0x40L;
        }
        notifyPropertyChanged(BR.groupSet);
        super.requestRebind();
    }
    public void setGracePeriodVisibility(int GracePeriodVisibility) {
        this.mGracePeriodVisibility = GracePeriodVisibility;
        synchronized(this) {
            mDirtyFlags |= 0x80L;
        }
        notifyPropertyChanged(BR.gracePeriodVisibility);
        super.requestRebind();
    }
    public void setCaMaxPointsError(@Nullable java.lang.String CaMaxPointsError) {
        this.mCaMaxPointsError = CaMaxPointsError;
        synchronized(this) {
            mDirtyFlags |= 0x100L;
        }
        notifyPropertyChanged(BR.caMaxPointsError);
        super.requestRebind();
    }
    public void setFileSubmissionVisibility(int FileSubmissionVisibility) {
        this.mFileSubmissionVisibility = FileSubmissionVisibility;
        synchronized(this) {
            mDirtyFlags |= 0x200L;
        }
        notifyPropertyChanged(BR.fileSubmissionVisibility);
        super.requestRebind();
    }
    public void setGracePeriodTime(long GracePeriodTime) {
        this.mGracePeriodTime = GracePeriodTime;
        synchronized(this) {
            mDirtyFlags |= 0x400L;
        }
        notifyPropertyChanged(BR.gracePeriodTime);
        super.requestRebind();
    }
    public void setCompletionCriteriaOptions(@Nullable java.util.List<com.ustadmobile.core.util.IdOption> CompletionCriteriaOptions) {
        this.mCompletionCriteriaOptions = CompletionCriteriaOptions;
        synchronized(this) {
            mDirtyFlags |= 0x800L;
        }
        notifyPropertyChanged(BR.completionCriteriaOptions);
        super.requestRebind();
    }
    public void setTextLimitTypeOptions(@Nullable java.util.List<com.ustadmobile.core.util.IdOption> TextLimitTypeOptions) {
        this.mTextLimitTypeOptions = TextLimitTypeOptions;
        synchronized(this) {
            mDirtyFlags |= 0x1000L;
        }
        notifyPropertyChanged(BR.textLimitTypeOptions);
        super.requestRebind();
    }
    public void setSubmissionPolicy(@Nullable java.util.List<com.ustadmobile.core.util.IdOption> SubmissionPolicy) {
        this.mSubmissionPolicy = SubmissionPolicy;
        synchronized(this) {
            mDirtyFlags |= 0x2000L;
        }
        notifyPropertyChanged(BR.submissionPolicy);
        super.requestRebind();
    }
    public void setStartTime(long StartTime) {
        this.mStartTime = StartTime;
        synchronized(this) {
            mDirtyFlags |= 0x4000L;
        }
        notifyPropertyChanged(BR.startTime);
        super.requestRebind();
    }
    public void setFileRequiredListener(@Nullable android.widget.CompoundButton.OnCheckedChangeListener FileRequiredListener) {
        this.mFileRequiredListener = FileRequiredListener;
        synchronized(this) {
            mDirtyFlags |= 0x8000L;
        }
        notifyPropertyChanged(BR.fileRequiredListener);
        super.requestRebind();
    }
    public void setDeadlineTime(long DeadlineTime) {
        this.mDeadlineTime = DeadlineTime;
        synchronized(this) {
            mDirtyFlags |= 0x10000L;
        }
        notifyPropertyChanged(BR.deadlineTime);
        super.requestRebind();
    }
    public void setMarkingTypeOptions(@Nullable java.util.List<com.ustadmobile.core.util.IdOption> MarkingTypeOptions) {
        this.mMarkingTypeOptions = MarkingTypeOptions;
        synchronized(this) {
            mDirtyFlags |= 0x20000L;
        }
        notifyPropertyChanged(BR.markingTypeOptions);
        super.requestRebind();
    }
    public void setTextRequiredListener(@Nullable android.widget.CompoundButton.OnCheckedChangeListener TextRequiredListener) {
        this.mTextRequiredListener = TextRequiredListener;
        synchronized(this) {
            mDirtyFlags |= 0x40000L;
        }
        notifyPropertyChanged(BR.textRequiredListener);
        super.requestRebind();
    }
    public void setLoading(boolean Loading) {
        this.mLoading = Loading;
    }
    public void setCaGracePeriodError(@Nullable java.lang.String CaGracePeriodError) {
        this.mCaGracePeriodError = CaGracePeriodError;
        synchronized(this) {
            mDirtyFlags |= 0x100000L;
        }
        notifyPropertyChanged(BR.caGracePeriodError);
        super.requestRebind();
    }
    public void setMPresenter(@Nullable com.ustadmobile.core.controller.ClazzAssignmentEditPresenter MPresenter) {
        this.mMPresenter = MPresenter;
        synchronized(this) {
            mDirtyFlags |= 0x200000L;
        }
        notifyPropertyChanged(BR.mPresenter);
        super.requestRebind();
    }
    public void setTimeZone(@Nullable java.lang.String TimeZone) {
        this.mTimeZone = TimeZone;
        synchronized(this) {
            mDirtyFlags |= 0x400000L;
        }
        notifyPropertyChanged(BR.timeZone);
        super.requestRebind();
    }
    public void setFieldsEnabled(boolean FieldsEnabled) {
        this.mFieldsEnabled = FieldsEnabled;
        synchronized(this) {
            mDirtyFlags |= 0x800000L;
        }
        notifyPropertyChanged(BR.fieldsEnabled);
        super.requestRebind();
    }
    public void setGroupSetEnabled(@Nullable java.lang.Boolean GroupSetEnabled) {
        this.mGroupSetEnabled = GroupSetEnabled;
        synchronized(this) {
            mDirtyFlags |= 0x1000000L;
        }
        notifyPropertyChanged(BR.groupSetEnabled);
        super.requestRebind();
    }
    public void setCaTitleError(@Nullable java.lang.String CaTitleError) {
        this.mCaTitleError = CaTitleError;
        synchronized(this) {
            mDirtyFlags |= 0x2000000L;
        }
        notifyPropertyChanged(BR.caTitleError);
        super.requestRebind();
    }
    public void setStartDate(long StartDate) {
        this.mStartDate = StartDate;
        synchronized(this) {
            mDirtyFlags |= 0x4000000L;
        }
        notifyPropertyChanged(BR.startDate);
        super.requestRebind();
    }
    public void setCaDeadlineError(@Nullable java.lang.String CaDeadlineError) {
        this.mCaDeadlineError = CaDeadlineError;
        synchronized(this) {
            mDirtyFlags |= 0x8000000L;
        }
        notifyPropertyChanged(BR.caDeadlineError);
        super.requestRebind();
    }
    public void setBlockWithAssignment(@Nullable com.ustadmobile.lib.db.entities.CourseBlockWithEntity BlockWithAssignment) {
        this.mBlockWithAssignment = BlockWithAssignment;
        synchronized(this) {
            mDirtyFlags |= 0x10000000L;
        }
        notifyPropertyChanged(BR.blockWithAssignment);
        super.requestRebind();
    }

    @Override
    public void setLifecycleOwner(@Nullable androidx.lifecycle.LifecycleOwner lifecycleOwner) {
        super.setLifecycleOwner(lifecycleOwner);
        caEditCommonFields.setLifecycleOwner(lifecycleOwner);
    }

    @Override
    protected boolean onFieldChange(int localFieldId, Object object, int fieldId) {
        switch (localFieldId) {
            case 0 :
                return onChangeCaEditCommonFields((com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBinding) object, fieldId);
        }
        return false;
    }
    private boolean onChangeCaEditCommonFields(com.toughra.ustadmobile.databinding.ItemCourseBlockCommonDetailBinding CaEditCommonFields, int fieldId) {
        if (fieldId == BR._all) {
            synchronized(this) {
                    mDirtyFlags |= 0x1L;
            }
            return true;
        }
        return false;
    }

    @Override
    protected void executeBindings() {
        long dirtyFlags = 0;
        synchronized(this) {
            dirtyFlags = mDirtyFlags;
            mDirtyFlags = 0;
        }
        long deadlineDate = mDeadlineDate;
        java.util.List<com.ustadmobile.core.util.IdOption> fileTypeOptions = mFileTypeOptions;
        int textSubmissionVisibility = mTextSubmissionVisibility;
        long gracePeriodDate = mGracePeriodDate;
        java.lang.String blockWithAssignmentAssignmentCaTitle = null;
        com.ustadmobile.lib.db.entities.CourseBlock courseBlockBlockWithAssignment = null;
        boolean blockWithAssignmentAssignmentCaPrivateCommentsEnabled = false;
        java.lang.String caStartDateError = mCaStartDateError;
        com.ustadmobile.lib.db.entities.CourseGroupSet groupSet = mGroupSet;
        boolean caTitleErrorJavaLangObjectNull = false;
        int gracePeriodVisibility = mGracePeriodVisibility;
        java.lang.String caMaxPointsError = mCaMaxPointsError;
        int fileSubmissionVisibility = mFileSubmissionVisibility;
        long gracePeriodTime = mGracePeriodTime;
        java.util.List<com.ustadmobile.core.util.IdOption> completionCriteriaOptions = mCompletionCriteriaOptions;
        java.util.List<com.ustadmobile.core.util.IdOption> textLimitTypeOptions = mTextLimitTypeOptions;
        boolean blockWithAssignmentAssignmentCaRequireFileSubmission = false;
        java.util.List<com.ustadmobile.core.util.IdOption> submissionPolicy = mSubmissionPolicy;
        long startTime = mStartTime;
        int blockWithAssignmentAssignmentCaFileType = 0;
        java.lang.String blockWithAssignmentAssignmentCaDescription = null;
        int blockWithAssignmentAssignmentCaTextLimit = 0;
        android.widget.CompoundButton.OnCheckedChangeListener fileRequiredListener = mFileRequiredListener;
        java.lang.String javaLangStringBlockWithAssignmentAssignmentCaTextLimit = null;
        long deadlineTime = mDeadlineTime;
        java.util.List<com.ustadmobile.core.util.IdOption> markingTypeOptions = mMarkingTypeOptions;
        android.widget.CompoundButton.OnCheckedChangeListener textRequiredListener = mTextRequiredListener;
        int blockWithAssignmentAssignmentCaNumberOfFiles = 0;
        com.ustadmobile.lib.db.entities.ClazzAssignment blockWithAssignmentAssignment = null;
        java.lang.String javaLangStringBlockWithAssignmentAssignmentCaNumberOfFiles = null;
        boolean blockWithAssignmentAssignmentCaRequireTextSubmission = false;
        int blockWithAssignmentAssignmentCaTextLimitType = 0;
        java.lang.String caGracePeriodError = mCaGracePeriodError;
        int blockWithAssignmentAssignmentCaSizeLimit = 0;
        boolean blockWithAssignmentAssignmentCaClassCommentEnabled = false;
        com.ustadmobile.core.controller.ClazzAssignmentEditPresenter mPresenter = mMPresenter;
        java.lang.String timeZone = mTimeZone;
        boolean fieldsEnabled = mFieldsEnabled;
        java.lang.Boolean groupSetEnabled = mGroupSetEnabled;
        java.lang.String caTitleError = mCaTitleError;
        java.lang.String javaLangStringBlockWithAssignmentAssignmentCaSizeLimit = null;
        long startDate = mStartDate;
        java.lang.String groupSetCgsName = null;
        boolean androidxDatabindingViewDataBindingSafeUnboxGroupSetEnabled = false;
        int blockWithAssignmentAssignmentCaSubmissionPolicy = 0;
        int blockWithAssignmentAssignmentCaMarkingType = 0;
        java.lang.String caDeadlineError = mCaDeadlineError;
        com.ustadmobile.lib.db.entities.CourseBlockWithEntity blockWithAssignment = mBlockWithAssignment;

        if ((dirtyFlags & 0x20000002L) != 0) {
        }
        if ((dirtyFlags & 0x30000004L) != 0) {
        }
        if ((dirtyFlags & 0x20000008L) != 0) {
        }
        if ((dirtyFlags & 0x20000010L) != 0) {
        }
        if ((dirtyFlags & 0x20000020L) != 0) {
        }
        if ((dirtyFlags & 0x20000040L) != 0) {



                if (groupSet != null) {
                    // read groupSet.cgsName
                    groupSetCgsName = groupSet.getCgsName();
                }
        }
        if ((dirtyFlags & 0x20000080L) != 0) {
        }
        if ((dirtyFlags & 0x20000100L) != 0) {
        }
        if ((dirtyFlags & 0x20000200L) != 0) {
        }
        if ((dirtyFlags & 0x20000400L) != 0) {
        }
        if ((dirtyFlags & 0x20000800L) != 0) {
        }
        if ((dirtyFlags & 0x30001000L) != 0) {
        }
        if ((dirtyFlags & 0x30002000L) != 0) {
        }
        if ((dirtyFlags & 0x20004000L) != 0) {
        }
        if ((dirtyFlags & 0x20008000L) != 0) {
        }
        if ((dirtyFlags & 0x20010000L) != 0) {
        }
        if ((dirtyFlags & 0x30020000L) != 0) {
        }
        if ((dirtyFlags & 0x20040000L) != 0) {
        }
        if ((dirtyFlags & 0x20100000L) != 0) {
        }
        if ((dirtyFlags & 0x20400000L) != 0) {
        }
        if ((dirtyFlags & 0x20800000L) != 0) {
        }
        if ((dirtyFlags & 0x21000000L) != 0) {



                // read androidx.databinding.ViewDataBinding.safeUnbox(groupSetEnabled)
                androidxDatabindingViewDataBindingSafeUnboxGroupSetEnabled = androidx.databinding.ViewDataBinding.safeUnbox(groupSetEnabled);
        }
        if ((dirtyFlags & 0x22000000L) != 0) {



                // read caTitleError != null
                caTitleErrorJavaLangObjectNull = (caTitleError) != (null);
        }
        if ((dirtyFlags & 0x24000000L) != 0) {
        }
        if ((dirtyFlags & 0x28000000L) != 0) {
        }
        if ((dirtyFlags & 0x30023004L) != 0) {


            if ((dirtyFlags & 0x30000000L) != 0) {

                    if (blockWithAssignment != null) {
                        // read (CourseBlock) blockWithAssignment
                        courseBlockBlockWithAssignment = ((com.ustadmobile.lib.db.entities.CourseBlock) (blockWithAssignment));
                    }
            }

                if (blockWithAssignment != null) {
                    // read blockWithAssignment.assignment
                    blockWithAssignmentAssignment = blockWithAssignment.getAssignment();
                }

            if ((dirtyFlags & 0x30000000L) != 0) {

                    if (blockWithAssignmentAssignment != null) {
                        // read blockWithAssignment.assignment.caTitle
                        blockWithAssignmentAssignmentCaTitle = blockWithAssignmentAssignment.getCaTitle();
                        // read blockWithAssignment.assignment.caPrivateCommentsEnabled
                        blockWithAssignmentAssignmentCaPrivateCommentsEnabled = blockWithAssignmentAssignment.getCaPrivateCommentsEnabled();
                        // read blockWithAssignment.assignment.caRequireFileSubmission
                        blockWithAssignmentAssignmentCaRequireFileSubmission = blockWithAssignmentAssignment.getCaRequireFileSubmission();
                        // read blockWithAssignment.assignment.caDescription
                        blockWithAssignmentAssignmentCaDescription = blockWithAssignmentAssignment.getCaDescription();
                        // read blockWithAssignment.assignment.caTextLimit
                        blockWithAssignmentAssignmentCaTextLimit = blockWithAssignmentAssignment.getCaTextLimit();
                        // read blockWithAssignment.assignment.caNumberOfFiles
                        blockWithAssignmentAssignmentCaNumberOfFiles = blockWithAssignmentAssignment.getCaNumberOfFiles();
                        // read blockWithAssignment.assignment.caRequireTextSubmission
                        blockWithAssignmentAssignmentCaRequireTextSubmission = blockWithAssignmentAssignment.getCaRequireTextSubmission();
                        // read blockWithAssignment.assignment.caSizeLimit
                        blockWithAssignmentAssignmentCaSizeLimit = blockWithAssignmentAssignment.getCaSizeLimit();
                        // read blockWithAssignment.assignment.caClassCommentEnabled
                        blockWithAssignmentAssignmentCaClassCommentEnabled = blockWithAssignmentAssignment.getCaClassCommentEnabled();
                    }


                    // read ("") + (blockWithAssignment.assignment.caTextLimit)
                    javaLangStringBlockWithAssignmentAssignmentCaTextLimit = ("") + (blockWithAssignmentAssignmentCaTextLimit);
                    // read ("") + (blockWithAssignment.assignment.caNumberOfFiles)
                    javaLangStringBlockWithAssignmentAssignmentCaNumberOfFiles = ("") + (blockWithAssignmentAssignmentCaNumberOfFiles);
                    // read ("") + (blockWithAssignment.assignment.caSizeLimit)
                    javaLangStringBlockWithAssignmentAssignmentCaSizeLimit = ("") + (blockWithAssignmentAssignmentCaSizeLimit);
            }
            if ((dirtyFlags & 0x30000004L) != 0) {

                    if (blockWithAssignmentAssignment != null) {
                        // read blockWithAssignment.assignment.caFileType
                        blockWithAssignmentAssignmentCaFileType = blockWithAssignmentAssignment.getCaFileType();
                    }
            }
            if ((dirtyFlags & 0x30001000L) != 0) {

                    if (blockWithAssignmentAssignment != null) {
                        // read blockWithAssignment.assignment.caTextLimitType
                        blockWithAssignmentAssignmentCaTextLimitType = blockWithAssignmentAssignment.getCaTextLimitType();
                    }
            }
            if ((dirtyFlags & 0x30002000L) != 0) {

                    if (blockWithAssignmentAssignment != null) {
                        // read blockWithAssignment.assignment.caSubmissionPolicy
                        blockWithAssignmentAssignmentCaSubmissionPolicy = blockWithAssignmentAssignment.getCaSubmissionPolicy();
                    }
            }
            if ((dirtyFlags & 0x30020000L) != 0) {

                    if (blockWithAssignmentAssignment != null) {
                        // read blockWithAssignment.assignment.caMarkingType
                        blockWithAssignmentAssignmentCaMarkingType = blockWithAssignmentAssignment.getCaMarkingType();
                    }
            }
        }
        // batch finished
        if ((dirtyFlags & 0x21000000L) != 0) {
            // api target 1

            this.caEditAssignmentType.setEnabled(androidxDatabindingViewDataBindingSafeUnboxGroupSetEnabled);
        }
        if ((dirtyFlags & 0x30000000L) != 0) {
            // api target 1

            androidx.databinding.adapters.CompoundButtonBindingAdapter.setChecked(this.caEditClassComments, blockWithAssignmentAssignmentCaClassCommentEnabled);
            this.caEditCommonFields.setBlock(courseBlockBlockWithAssignment);
            androidx.databinding.adapters.TextViewBindingAdapter.setText(this.caEditDescText, blockWithAssignmentAssignmentCaDescription);
            androidx.databinding.adapters.TextViewBindingAdapter.setText(this.caEditFileSizeLimitDesc, javaLangStringBlockWithAssignmentAssignmentCaSizeLimit);
            androidx.databinding.adapters.TextViewBindingAdapter.setText(this.caEditNumberOfFilesDesc, javaLangStringBlockWithAssignmentAssignmentCaNumberOfFiles);
            androidx.databinding.adapters.TextViewBindingAdapter.setText(this.caEditNumberOfWordsDesc, javaLangStringBlockWithAssignmentAssignmentCaTextLimit);
            androidx.databinding.adapters.CompoundButtonBindingAdapter.setChecked(this.caEditPrivateComments, blockWithAssignmentAssignmentCaPrivateCommentsEnabled);
            androidx.databinding.adapters.CompoundButtonBindingAdapter.setChecked(this.caEditRequireFileSubmission, blockWithAssignmentAssignmentCaRequireFileSubmission);
            androidx.databinding.adapters.CompoundButtonBindingAdapter.setChecked(this.caEditRequireTextSubmission, blockWithAssignmentAssignmentCaRequireTextSubmission);
            androidx.databinding.adapters.TextViewBindingAdapter.setText(this.caTitleText, blockWithAssignmentAssignmentCaTitle);
        }
        if ((dirtyFlags & 0x20000000L) != 0) {
            // api target 1

            androidx.databinding.adapters.CompoundButtonBindingAdapter.setListeners(this.caEditClassComments, (android.widget.CompoundButton.OnCheckedChangeListener)null, caEditClassCommentsandroidCheckedAttrChanged);
            setBindingInverseListener(this.caEditCommonFields, this.mOldEventBlock94713904, caEditCommonFieldsblock);
            setBindingInverseListener(this.caEditCommonFields, this.mOldEventStartDate290354820, caEditCommonFieldsstartDate);
            setBindingInverseListener(this.caEditCommonFields, this.mOldEventStartTime191363530, caEditCommonFieldsstartTime);
            setBindingInverseListener(this.caEditCommonFields, this.mOldEventDeadlineDate617772217, caEditCommonFieldsdeadlineDate);
            setBindingInverseListener(this.caEditCommonFields, this.mOldEventDeadlineTime374556725, caEditCommonFieldsdeadlineTime);
            setBindingInverseListener(this.caEditCommonFields, this.mOldEventGracePeriodDate1431979498, caEditCommonFieldsgracePeriodDate);
            setBindingInverseListener(this.caEditCommonFields, this.mOldEventGracePeriodTime397651991, caEditCommonFieldsgracePeriodTime);
            this.caEditCommonFields.setMinScoreVisible(false);
            androidx.databinding.adapters.TextViewBindingAdapter.setTextWatcher(this.caEditDescText, (androidx.databinding.adapters.TextViewBindingAdapter.BeforeTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.OnTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.AfterTextChanged)null, caEditDescTextandroidTextAttrChanged);
            this.caEditDescriptionTextinput.setHint(com.ustadmobile.port.android.view.ext.StringExtKt.optional(getRoot().getContext(), caEditDescriptionTextinput.getResources().getString(R.string.description)));
            androidx.databinding.adapters.TextViewBindingAdapter.setTextWatcher(this.caEditFileSizeLimitDesc, (androidx.databinding.adapters.TextViewBindingAdapter.BeforeTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.OnTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.AfterTextChanged)null, caEditFileSizeLimitDescandroidTextAttrChanged);
            com.ustadmobile.port.android.view.binding.EditTextBindingsKt.setMinMax(this.caEditNumberOfFilesDesc, 0, 100);
            androidx.databinding.adapters.TextViewBindingAdapter.setTextWatcher(this.caEditNumberOfFilesDesc, (androidx.databinding.adapters.TextViewBindingAdapter.BeforeTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.OnTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.AfterTextChanged)null, caEditNumberOfFilesDescandroidTextAttrChanged);
            androidx.databinding.adapters.TextViewBindingAdapter.setTextWatcher(this.caEditNumberOfWordsDesc, (androidx.databinding.adapters.TextViewBindingAdapter.BeforeTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.OnTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.AfterTextChanged)null, caEditNumberOfWordsDescandroidTextAttrChanged);
            androidx.databinding.adapters.CompoundButtonBindingAdapter.setListeners(this.caEditPrivateComments, (android.widget.CompoundButton.OnCheckedChangeListener)null, caEditPrivateCommentsandroidCheckedAttrChanged);
            androidx.databinding.adapters.TextViewBindingAdapter.setTextWatcher(this.caTitleText, (androidx.databinding.adapters.TextViewBindingAdapter.BeforeTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.OnTextChanged)null, (androidx.databinding.adapters.TextViewBindingAdapter.AfterTextChanged)null, caTitleTextandroidTextAttrChanged);
            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setSelectedMessageIdListener(this.mboundView10, mboundView10selectedMessageIdOptionAttrChanged);
            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setSelectedMessageIdListener(this.mboundView17, mboundView17selectedMessageIdOptionAttrChanged);
            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setSelectedMessageIdListener(this.mboundView20, mboundView20selectedMessageIdOptionAttrChanged);
            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setSelectedMessageIdListener(this.mboundView21, mboundView21selectedMessageIdOptionAttrChanged);
            this.mboundView7.setOnClickListener(mCallback17);
            com.ustadmobile.port.android.view.binding.EditTextBindingsKt.setRunOnClickWhenFocused(this.mboundView7, true);
            // api target 3
            if(getBuildSdkInt() >= 3) {

                this.mboundView7.setInputType(android.text.InputType.TYPE_NULL);
            }
        }
        if ((dirtyFlags & 0x20400000L) != 0) {
            // api target 1

            this.caEditCommonFields.setTimeZone(timeZone);
        }
        if ((dirtyFlags & 0x24000000L) != 0) {
            // api target 1

            this.caEditCommonFields.setStartDate(startDate);
        }
        if ((dirtyFlags & 0x20004000L) != 0) {
            // api target 1

            this.caEditCommonFields.setStartTime(startTime);
        }
        if ((dirtyFlags & 0x20000002L) != 0) {
            // api target 1

            this.caEditCommonFields.setDeadlineDate(deadlineDate);
        }
        if ((dirtyFlags & 0x20010000L) != 0) {
            // api target 1

            this.caEditCommonFields.setDeadlineTime(deadlineTime);
        }
        if ((dirtyFlags & 0x20000010L) != 0) {
            // api target 1

            this.caEditCommonFields.setGracePeriodDate(gracePeriodDate);
        }
        if ((dirtyFlags & 0x20000400L) != 0) {
            // api target 1

            this.caEditCommonFields.setGracePeriodTime(gracePeriodTime);
        }
        if ((dirtyFlags & 0x20100000L) != 0) {
            // api target 1

            this.caEditCommonFields.setCaGracePeriodError(caGracePeriodError);
        }
        if ((dirtyFlags & 0x28000000L) != 0) {
            // api target 1

            this.caEditCommonFields.setCaDeadlineError(caDeadlineError);
        }
        if ((dirtyFlags & 0x20000020L) != 0) {
            // api target 1

            this.caEditCommonFields.setCaStartDateError(caStartDateError);
        }
        if ((dirtyFlags & 0x20000100L) != 0) {
            // api target 1

            this.caEditCommonFields.setCaMaxPointsError(caMaxPointsError);
        }
        if ((dirtyFlags & 0x20000800L) != 0) {
            // api target 1

            this.caEditCommonFields.setCompletionCriteriaOptions(completionCriteriaOptions);
        }
        if ((dirtyFlags & 0x20000080L) != 0) {
            // api target 1

            this.caEditCommonFields.setGracePeriodVisibility(gracePeriodVisibility);
        }
        if ((dirtyFlags & 0x20800000L) != 0) {
            // api target 1

            this.caEditDescText.setEnabled(fieldsEnabled);
            this.caEditDescriptionTextinput.setEnabled(fieldsEnabled);
            this.caEditFileSizeLimit.setEnabled(fieldsEnabled);
            this.caEditFileSizeLimitDesc.setEnabled(fieldsEnabled);
            this.caEditNumberOfFiles.setEnabled(fieldsEnabled);
            this.caEditNumberOfFilesDesc.setEnabled(fieldsEnabled);
            this.caEditNumberOfWords.setEnabled(fieldsEnabled);
            this.caEditNumberOfWordsDesc.setEnabled(fieldsEnabled);
            this.caTitleInput.setEnabled(fieldsEnabled);
            this.caTitleText.setEnabled(fieldsEnabled);
        }
        if ((dirtyFlags & 0x20000200L) != 0) {
            // api target 1

            this.caEditFileSizeLimit.setVisibility(fileSubmissionVisibility);
            this.caEditFileType.setVisibility(fileSubmissionVisibility);
            this.caEditNumberOfFiles.setVisibility(fileSubmissionVisibility);
        }
        if ((dirtyFlags & 0x20000008L) != 0) {
            // api target 1

            this.caEditNumberOfWords.setVisibility(textSubmissionVisibility);
            this.caEditWordLimit.setVisibility(textSubmissionVisibility);
        }
        if ((dirtyFlags & 0x20008000L) != 0) {
            // api target 1

            androidx.databinding.adapters.CompoundButtonBindingAdapter.setListeners(this.caEditRequireFileSubmission, fileRequiredListener, caEditRequireFileSubmissionandroidCheckedAttrChanged);
        }
        if ((dirtyFlags & 0x20040000L) != 0) {
            // api target 1

            androidx.databinding.adapters.CompoundButtonBindingAdapter.setListeners(this.caEditRequireTextSubmission, textRequiredListener, caEditRequireTextSubmissionandroidCheckedAttrChanged);
        }
        if ((dirtyFlags & 0x22000000L) != 0) {
            // api target 1

            this.caTitleInput.setErrorEnabled(caTitleErrorJavaLangObjectNull);
            com.ustadmobile.port.android.view.binding.TextInputLayoutBindingsKt.setErrorText(this.caTitleInput, caTitleError);
        }
        if ((dirtyFlags & 0x30000004L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setMessageIdOptions(this.mboundView10, fileTypeOptions, blockWithAssignmentAssignmentCaFileType);
        }
        if ((dirtyFlags & 0x30001000L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setMessageIdOptions(this.mboundView17, textLimitTypeOptions, blockWithAssignmentAssignmentCaTextLimitType);
        }
        if ((dirtyFlags & 0x30002000L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setMessageIdOptions(this.mboundView20, submissionPolicy, blockWithAssignmentAssignmentCaSubmissionPolicy);
        }
        if ((dirtyFlags & 0x30020000L) != 0) {
            // api target 1

            com.ustadmobile.port.android.view.binding.MessageIdAutoCompleteTextViewBindingsKt.setMessageIdOptions(this.mboundView21, markingTypeOptions, blockWithAssignmentAssignmentCaMarkingType);
        }
        if ((dirtyFlags & 0x20000040L) != 0) {
            // api target 1

            androidx.databinding.adapters.TextViewBindingAdapter.setText(this.mboundView7, groupSetCgsName);
        }
        if ((dirtyFlags & 0x20000000L) != 0) {
            this.mOldEventBlock94713904 = caEditCommonFieldsblock;
            this.mOldEventStartDate290354820 = caEditCommonFieldsstartDate;
            this.mOldEventStartTime191363530 = caEditCommonFieldsstartTime;
            this.mOldEventDeadlineDate617772217 = caEditCommonFieldsdeadlineDate;
            this.mOldEventDeadlineTime374556725 = caEditCommonFieldsdeadlineTime;
            this.mOldEventGracePeriodDate1431979498 = caEditCommonFieldsgracePeriodDate;
            this.mOldEventGracePeriodTime397651991 = caEditCommonFieldsgracePeriodTime;
        }
        executeBindingsOn(caEditCommonFields);
    }
    // Listener Stub Implementations
    // callback impls
    public final void _internalCallbackOnClick(int sourceId , android.view.View callbackArg_0) {
        // localize variables for thread safety
        // mPresenter != null
        boolean mPresenterJavaLangObjectNull = false;
        // mPresenter
        com.ustadmobile.core.controller.ClazzAssignmentEditPresenter mPresenter = mMPresenter;



        mPresenterJavaLangObjectNull = (mPresenter) != (null);
        if (mPresenterJavaLangObjectNull) {


            mPresenter.handleSubmissionTypeClicked();
        }
    }
    // dirty flag
    private  long mDirtyFlags = 0xffffffffffffffffL;
    /* flag mapping
        flag 0 (0x1L): caEditCommonFields
        flag 1 (0x2L): deadlineDate
        flag 2 (0x3L): fileTypeOptions
        flag 3 (0x4L): textSubmissionVisibility
        flag 4 (0x5L): gracePeriodDate
        flag 5 (0x6L): caStartDateError
        flag 6 (0x7L): groupSet
        flag 7 (0x8L): gracePeriodVisibility
        flag 8 (0x9L): caMaxPointsError
        flag 9 (0xaL): fileSubmissionVisibility
        flag 10 (0xbL): gracePeriodTime
        flag 11 (0xcL): completionCriteriaOptions
        flag 12 (0xdL): textLimitTypeOptions
        flag 13 (0xeL): submissionPolicy
        flag 14 (0xfL): startTime
        flag 15 (0x10L): fileRequiredListener
        flag 16 (0x11L): deadlineTime
        flag 17 (0x12L): markingTypeOptions
        flag 18 (0x13L): textRequiredListener
        flag 19 (0x14L): loading
        flag 20 (0x15L): caGracePeriodError
        flag 21 (0x16L): mPresenter
        flag 22 (0x17L): timeZone
        flag 23 (0x18L): fieldsEnabled
        flag 24 (0x19L): groupSetEnabled
        flag 25 (0x1aL): caTitleError
        flag 26 (0x1bL): startDate
        flag 27 (0x1cL): caDeadlineError
        flag 28 (0x1dL): blockWithAssignment
        flag 29 (0x1eL): null
    flag mapping end*/
    //end
}